"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.calcStartOf = exports.countWeeks = exports.getMonday = void 0;
const date_fns_1 = require("date-fns");
const getMonday = (date) => {
    date = new Date(date);
    const day = date.getDay();
    const diff = date.getDate() - day + (day == 0 ? -6 : 1);
    return new Date(new Date(date.setDate(diff)).setHours(0, 0, 0, 0));
};
exports.getMonday = getMonday;
const countWeeks = (start, end) => Math.round((end.getTime() - start.getTime()) / 1000 / 60 / 60 / 24 / 7);
exports.countWeeks = countWeeks;
const calcStartOf = (startOf, weekOfMonth) => {
    const startOfFirstMonthWeek = (0, exports.getMonday)(startOf);
    const startOfYear = new Date(startOf.getFullYear(), 0, 1);
    const startOfFirstYearWeek = (0, exports.getMonday)(startOfYear);
    const weekOfYear = (0, exports.countWeeks)(startOfFirstYearWeek, startOfFirstMonthWeek) + 1 + weekOfMonth;
    return (0, date_fns_1.setWeek)(startOfFirstMonthWeek, weekOfYear, { weekStartsOn: 1 });
};
exports.calcStartOf = calcStartOf;
